import { __extends } from "tslib";
import * as am4core from '@amcharts/amcharts4/core';
import am4lang_it_IT from '@amcharts/amcharts4/lang/it_IT';
import * as am4maps from '@amcharts/amcharts4/maps';
import am4themesAnimated from '@amcharts/amcharts4/themes/animated';
import { am4themesJobValue } from '@jobvalue/utils';
import React, { PureComponent } from 'react';
import uuid from 'uuid/v4';
import provinces from '../data/provinces';
am4core.useTheme(am4themesAnimated);
am4core.useTheme(am4themesJobValue);
am4core.options.commercialLicense = true;
var LabourCostChart = /** @class */ (function (_super) {
    __extends(LabourCostChart, _super);
    function LabourCostChart(props) {
        var _this = _super.call(this, props) || this;
        _this.chart = undefined;
        _this.drawChart = function () {
            var province = _this.props.province;
            if (!_this.chart) {
                var chart_1 = am4core.create(_this.uuid, am4maps.MapChart);
                chart_1.language.locale = am4lang_it_IT;
                chart_1.geodata = provinces;
                chart_1.projection = new am4maps.projections.Miller();
                var polygonSeries_1 = chart_1.series.push(new am4maps.MapPolygonSeries());
                polygonSeries_1.useGeodata = true;
                var polygonTemplate = polygonSeries_1.mapPolygons.template;
                var hs = polygonTemplate.states.create('hover');
                hs.properties.fill = am4core.color('#386da7');
                polygonTemplate.tooltipText = '{SIGLA}';
                polygonSeries_1.data = [
                    {
                        id: province.code,
                        name: province.name,
                        fill: am4core.color('#386da7'),
                    },
                ];
                // chart.exporting.adapter.add('zoomLevel', data => {
                //   return data;
                // });
                chart_1.events.on('ready', function () {
                    chart_1.zoomToMapObject(polygonSeries_1.getPolygonById(province.code), 4.5);
                    chart_1.seriesContainer.resizable = false;
                });
                chart_1.seriesContainer.draggable = false;
                chart_1.seriesContainer.resizable = false;
                chart_1.chartContainer.wheelable = false;
                chart_1.seriesContainer.events.disableType('doublehit');
                chart_1.chartContainer.background.events.disableType('doublehit');
                // Bind "fill" property to "fill" key in data
                polygonTemplate.propertyFields.fill = 'fill';
                _this.chart = chart_1;
            }
        };
        _this.uuid = props.id || uuid();
        return _this;
    }
    LabourCostChart.prototype.componentDidMount = function () {
        this.drawChart();
    };
    LabourCostChart.prototype.componentDidUpdate = function () {
        this.drawChart();
    };
    LabourCostChart.prototype.componentWillUnmount = function () {
        if (this.chart) {
            this.chart.dispose();
        }
    };
    LabourCostChart.prototype.render = function () {
        return (React.createElement("div", { style: { overflowX: 'auto' } },
            React.createElement("div", { id: this.uuid, style: { width: '100%', height: 200 } })));
    };
    LabourCostChart.defaultProps = {
        aspect: 2,
        className: 'mt-3 mb-4',
        margin: { top: 0, right: 0, left: 0, bottom: 0 },
    };
    return LabourCostChart;
}(PureComponent));
export default LabourCostChart;
//# sourceMappingURL=Province.js.map